package {

	import Box2DAS.Dynamics.ContactEvent;

	import com.citrusengine.objects.platformer.Platform;

	import org.osflash.signals.Signal;

	/**
	 * @author Aymeric
	 */
	public class Brick extends Platform {

		public var onEndContact:Signal;

		public function Brick(name:String, params:Object = null) {

			super(name, params);
			onEndContact = new Signal(ContactEvent);
		}

		override public function destroy():void {

			onEndContact.removeAll();
			_fixture.removeEventListener(ContactEvent.END_CONTACT, handleEndContact);
			super.destroy();
		}

		override protected function createFixture():void {
			
			super.createFixture();
			_fixture.m_reportEndContact = true;
			_fixture.addEventListener(ContactEvent.END_CONTACT, handleEndContact);
		}

		protected function handleEndContact(e:ContactEvent):void {
			onEndContact.dispatch(e);
		}
	}
}
